diff --git a/src/backend/access/hash/hash_xlog.c b/src/backend/access/hash/hash_xlog.c
index ee02d9a..064caa8 100644
--- a/src/backend/access/hash/hash_xlog.c
+++ b/src/backend/access/hash/hash_xlog.c
@@ -1249,4 +1249,10 @@ hash_mask(char *pagedata, BlockNumber blkno)
 		 */
 		mask_lp_flags(page);
 	}
+
+	/*
+	 * LH_PAGE_HAS_DEAD_TUPLES is just an un-logged hint bit. So, mask it.
+	 * See _hash_kill_items() for details.
+	 */
+	opaque->hasho_flag &= ~LH_PAGE_HAS_DEAD_TUPLES;
 }
